//prelude 预导入: Rust 会导入一些默认的模块供给使用，但是其他的就需要手动使用use导入
use std::{cmp::Ordering, io};
use rand::{Rng, thread_rng};

fn main() {
    println!("猜数游戏");

    let mut rng = thread_rng();
    let secret_num:u32= rng.gen_range(1..100);
    // println!("神秘数字是 {}", secret_num);
    loop {
        println!("请猜测一个数字");
        let mut guess = String::new();
        let str_len = io::stdin().read_line(&mut guess).expect("读取行错误错误");
        // println!("你输入的内容长度是 {}， 内容为：{}",str_len, guess);
        let guess:u32 = match guess.trim().parse() {
            Ok(num) => num,
            Err(_) => {
                println!("字符串非数字无法解析");
                continue;
            }
        };
        match guess.cmp(&secret_num){
            Ordering::Less => println!("你猜的数字太小"),
            Ordering::Greater => println!("你猜的数字太大"),
            Ordering::Equal => {println!("你猜对了");break;},
        }
    }
}
