use std::env;
use std::process;

use minigrep;

fn main() {
    let args: Vec<String> = env::args().collect();
    if args.len() < 3 {
        eprintln!("Usage: {} <text> <input file>", &args[0]);
        return;
    }
    let args = &args[1..];
    let config = minigrep::Config::new(args).unwrap_or_else(|err| {
        println!("Problem: {}", err);
        process::exit(-1);
    });
    let result = minigrep::run(&config).unwrap_or_else(|err| {
        println!("Problem: {}", err);
        process::exit(-1);
    });
    println!("find {} in {}, is:", config.query, config.filename);
    for it in result {
        println!("{}", it);
    }
}
