fn main() {
    println!("Hello, world!");
    mutex_learn();
}

use std::sync::{Arc, Mutex};
use std::thread;
use std::time::Duration;

fn mutex_learn() {
    let strings = Arc::new(Mutex::new(vec![]));
    let mut ths = vec![];
    for i in 1..10 {
        let strings = Arc::clone(&strings); //获得一个强引用
        let handle = thread::spawn(move || {
            for _i in 1..3 {
                strings
                    .lock()
                    .unwrap()
                    .push(String::from(format!("thread{}: ", i)) + &(i + _i).to_string());
                thread::sleep(Duration::from_micros(
                    (((1 as f64) / (i as f64)) * 100.0) as u64, //线程越前的睡的越久
                ));
            }
        });
        ths.push(handle);
    }

    for th in ths {
        th.join().unwrap();
    }
    println!("strings is {:?}", strings.lock().unwrap());
}
