use shared_trait::*;

struct SelectBox<'a> {
    width: i32,
    height: u32,
    option: Vec<&'a str>,
}

impl<'a> Draw for SelectBox<'a> {
    fn draw(&self) {
        println!(
            "This is a Button, draw by {}x{} : {:?}",
            self.width, self.height, self.option
        );
    }
}

fn main() {
    println!("Hello, world!");
    let mut screen = Screen::new();

    let button = Button::new(30, 40, "Button text");
    screen.add(Box::new(button));
    screen.add(Box::new(SelectBox {
        width: 100,
        height: 300,
        option: vec!["option1", "option2", "option3"],
    }));

    // screen.add(Box::new(String::from("asdad"))); //the trait bound `String: shared_trait::Draw` is not satisfied
    screen.run();
}
